package com.ibm.xml.xpointer;

import java.io.Serializable;

public class StringTerm implements OtherTerm, Serializable {
   static final long serialVersionUID = -5213912898288372011L;
   boolean isAll;
   int instance;
   String string;
   boolean isPosition;
   boolean isEnd;
   int position;
   int length;

   public StringTerm(boolean var1, int var2, String var3, boolean var4, boolean var5, int var6, int var7) {
      this.isAll = false;
      this.instance = -1;
      this.isPosition = false;
      this.isEnd = false;
      this.position = -1;
      this.length = -1;
      this.isAll = var1;
      this.instance = var2;
      this.string = var3;
      this.isPosition = var4;
      this.isEnd = var5;
      this.position = var6;
      this.length = var7;
   }

   public StringTerm(int var1, String var2, int var3) {
      this(false, var1, var2, false, false, var3, 0);
   }

   public StringTerm(String var1, int var2) {
      this(true, -1, var1, false, false, var2, 0);
   }

   public StringTerm(int var1, String var2, boolean var3) {
      this(false, var1, var2, false, var3, 1, 0);
   }

   public StringTerm(String var1, boolean var2) {
      this(true, -1, var1, false, var2, 1, 0);
   }

   public StringTerm(int var1, String var2) {
      this(false, var1, var2, false, false, 1, 0);
   }

   public StringTerm(String var1) {
      this(true, -1, var1, false, false, 1, 0);
   }

   public boolean isAll() {
      return this.isAll;
   }

   public int getInstance() {
      return this.instance;
   }

   public String getString() {
      return this.string;
   }

   public boolean hasPosition() {
      return this.isPosition;
   }

   public boolean isEnd() {
      return this.isEnd;
   }

   public int getPosition() {
      return this.position;
   }

   public int getLength() {
      return this.length;
   }

   public String toString() {
      StringBuffer var1 = new StringBuffer();
      var1.append(XPointer.literals[14]);
      var1.append("(");
      var1.append(this.isAll ? "all" : Integer.toString(this.instance));
      var1.append(",");
      var1.append(XPointerParser.makeSkipLit(this.string));
      if (this.isPosition) {
         var1.append(",");
         var1.append(this.isEnd ? "end" : Integer.toString(this.position));
         if (this.length >= 0) {
            var1.append(",");
            var1.append(Integer.toString(this.length));
         }
      }

      var1.append(")");
      return var1.toString();
   }
}
